#pragma once
#include <iostream>


class DBGStream
{
    bool dbg;

public:
    DBGStream() {dbg=false;}
    DBGStream(bool x) {dbg=x;}
    void set_debug(bool x) {dbg=x;}

    // override << operator
    template <typename T>
    DBGStream& operator<<(const T& x)
    {
        if(dbg) std::cout << x;
        return *this;
    }

    // this is the type of std::cout
    typedef std::basic_ostream<char, std::char_traits<char> > CoutType;

    // this is the function signature of std::endl
    typedef CoutType& (*StandardEndLine)(CoutType&);

    // define an operator<< to take in std::endl
    DBGStream& operator<<(StandardEndLine manip)
    {
        // call the function, but we cannot return it's value
        if(dbg) manip(std::cout);
        return *this;
    }

};




extern DBGStream DEBUG_OUT;

